#!/usr/bin/perl

use LWP::UserAgent;
use IO::Socket::INET;

my $ADDR_PREFIX="10.23";
my @STATE = ("OK", "CRITICAL");
my $ok = 0;
my $endpoint = "localhost";
my $port = 4747;
my $counter = 0;
my $a = 255;
my $b = 1;

my $socket = IO::Socket::INET->new ( PeerHost => $endpoint, PeerPort => $port, Proto => 'tcp', );

while (isSocketConnected()) { 
    my $event_type = join "", map { (q(a)..q(z))[rand(26)] } 1 .. 4;
    $counter++;
    $a--;
    $a = 255 if $a < 1;
    $b+=3;
    $b = 1 if $b > 255; 
    $ok = !$ok;
    
    my $payload = "{\"type\":\"$event_type\", \"created_ms\":0, \"payload\":{\"output\":\"$STATE[$ok] - PID:$$ Iteration: $counter\",\"address\":\"$ADDR_PREFIX.$a.$b\"}}\n";
   # print $payload;
    $socket->send($payload);
}

sub isSocketConnected {
    return 0 unless defined $socket;
    return 0 unless $socket->connected;
    return 1;
}
